<template id="categoryFeed">
    <v-ons-page id="feed2">
        <div class="p-3" v-if="isAndroid()">
            <v-ons-search-input placeholder="Поиск" position="top" v-model="query" class="w-100"></v-ons-search-input>
        </div>

        <div class="px-3">
            <v-ons-select :class="['category-select w-100', isAndroid() ? '' : 'category-select--ios']"
                          v-model="selectedTag" v-if="tags.length > 0">
                <option value="">Выберите категорию</option>
                <option :value="tag.id" v-for="tag in tags">{{ tag.name }}</option>
            </v-ons-select>

            <div v-if="gestures.length > 0">
                <v-ons-list class="my-3">
                    <v-ons-list-item v-for="(gesture, index) in gestures" :key="index">
                        <h5 class="item-name">{{ gesture.word }}</h5>

                        <div class="video border-0 video--alphabetical" :data-video="gesture.youtube_url"
                             @click="loadYoutube($event)">
                            <div class="play-button">
                                <v-ons-icon icon="ion-ios-play-circle, material: md-play-circle"></v-ons-icon></div>
                            <img :src="gesture.cover" :alt="gesture.word">
                        </div>

                        <ul class="tags" v-if="gesture.tags">
                            <li class="tags__item" v-for="tag in gesture.tags" @click="selectedTag = tag.id">
                                {{ tag.name }}
                            </li>
                        </ul>

                    </v-ons-list-item>
                </v-ons-list>
            </div>

            <div class="m-5 text-center" v-else>
                <template v-if="searched">
                    Список пуст
                </template>
            </div>
            <div class="text-center mx-auto" id="progressBar2" v-if="isScrollable">
                <p v-if="!online && gestures.length === 0">
                    Нет интернет-подключения
                </p>
                <v-ons-progress-circular indeterminate class="center"></v-ons-progress-circular>
            </div>
        </div>

    </v-ons-page>
</template>

<script>
    export default {
        props: ['q'],
        data() {
            return {
                query: '',
                tags: [],
                gestures: [],
                selectedTag: '',
                scrolledToBottom: false,
                currentPage: 0,
                lastPage: 0,
                isScrollable: true,
                searched: false,
                online: window.navigator.onLine
            }
        },
        watch: {
            selectedTag() {
                this.getGestures('reset');
            },
            query() {
                this.$emit('changeQuery', this.query)
                this.getGestures('reset');
            },
            q() {
                this.query = this.q
            },
            scrolledToBottom() {
                if (this.scrolledToBottom) {
                    this.getGestures()
                }
            },
            currentPage () {
                if (this.currentPage && this.currentPage === this.lastPage) {
                    this.isScrollable = false
                } else {
                    this.isScrollable = true
                }
            }
        },
        mounted() {
            this.getTags();
            this.getGestures();
            document.getElementById('feed2').addEventListener('drag', this.onListDrag);
        },
        methods: {
            isAndroid() {
                return this.$ons.platform.isAndroid();
            },
            getTags() {
                axios.get(`/api/tags`)
                    .then(response => {
                        // JSON responses are automatically parsed.
                        this.tags = response.data
                    })
                    .catch(e => {
                        console.log('Проверьте интернет-подключение или повторите попытку позже!')
                    })
            },
            getGestures(option = '') {
                axios.get(`/api/gestures`, {
                    params: {
                        tag: this.selectedTag,
                        q: this.query,
                        per_page: 15,
                        page: this.currentPage + 1
                    }
                })
                    .then(response => {
                        if (option === 'reset') {
                            this.currentPage = 0
                            this.lastPage = 0
                            this.gestures = response.data.data
                        } else {
                            this.currentPage = response.data.current_page;
                            this.lastPage = response.data.last_page
                            this.gestures = this.gestures.concat(response.data.data)
                        }
                    })
                    .then(() => {
                        this.searched = true
                        this.scrolledToBottom = (option === 'reset')
                        this.$emit('gesturesDownloaded')
                    })
                    .catch(e => {
                        console.log('Проверьте интернет-подключение или повторите попытку позже!')
                    })
            },
            onListDrag(event) {
                if (this.isScrollable) {
                    let el = document.getElementById('progressBar2')
                    this.scrolledToBottom = this.isInViewport(el)
                }
            },
            isInViewport(elem) {
                let bounding = elem.getBoundingClientRect();
                return (
                    bounding.top >= 0 &&
                    bounding.left >= 0 &&
                    bounding.bottom <= (window.innerHeight || document.documentElement.clientHeight) &&
                    bounding.right <= (window.innerWidth || document.documentElement.clientWidth)
                );
            },
            loadYoutube(event) {
                let iframe = document.createElement("iframe");

                iframe.setAttribute("frameborder", "0");
                iframe.setAttribute("class", "border-0");
                iframe.setAttribute("allowfullscreen", "");
                iframe.setAttribute("src", event.currentTarget.dataset.video + '?rel=0&showinfo=0&autoplay=1');

                event.currentTarget.innerHTML = "";
                event.currentTarget.appendChild(iframe);
            }
        }
    }
</script>